-- File: erev.e
-- Author: Oscar Nierstrasz 30.11.95
-- Reverses the order of lines in the input using a dynamic stack.
-- The stack is implemented as a linked list.

class	EREV

-----------------------------------------------------------
creation { ANY }
	make

-----------------------------------------------------------
feature { NONE }

	ioStack : DYNAMICSTACK [STRING]

-----------------------------------------------------------
	make is
		do
			!!ioStack.make
			--
			-- Push input lines onto stack
			--
			from
				io.readline
			until
			    io.input.end_of_file
			loop
				ioStack.push(io.last_string)
				io.readline
			end
			--
			-- Pop them off in reverse order
			-- and print them all
			--
			from
			until	ioStack.empty
			loop
				io.putstring(ioStack.top)
				io.new_line
				ioStack.pop
			end
		end -- make

-----------------------------------------------------------
end -- class EREV
