
// File: rwrev.cpp
// Author: Oscar Nierstrasz 30.11.95
//
// Rogue Wave implementation of line reverser.

#include <iostream.h>
#include <exception.h>

#include <rw/cstring.h>
#include <rw/tstack.h>

#include <rw/tvdlist.h>
typedef RWTStack<RWCString, RWTValDlist<RWCString> > IOStack;

int main(void)
{
	RWCString buf;
	IOStack ioStack;

        // Push input lines onto stack
	//
	//
	while (buf.readLine(cin,
			FALSE)) // don't ignore white space!
	{
		ioStack.push(buf);
	}

	// Pop them off in reverse order and print them all
	//
	while (ioStack.entries() != 0)
	{
		cout << ioStack.pop() << endl;;
	}
	return 0;
}

