
// File: dstring.cpp
// Author: Oscar Nierstrasz 30.11.95

// #include <iostream.h>

#include "dstring.h"

// should each op leave string in consistent state
// with '\0' at end?


int
DString::getline(istream& in)
{
	// This will need quite a bit of tuning ...
	_string.zero();
	char c;
	while ((c = in.get()) != EOF) {
		if (c == '\n') {
			_string.push('\0');
			return 1;
		}
		_string.push(c);
	}
	return 0;
}

DString::DString(const char * init)
	: _string(1 + ::strlen(init),init)
{
}

DString&
DString::operator=(const DString& val)
{
	_string = val._string;
	return *this;
}
