
// dstring.h
// Author: Oscar Nierstrasz 30.11.95

#ifndef DSTRING_H
#define DSTRING_H

#include <exception.h>
#include <string.h>
#include "dstore.h"

class DString
{
public:
	DString(void) { _string.push('\0'); };
	~DString(void) { };
	// copy constructor:
	// DString(const DString& copy);
	DString(const char *init);

	// does not work ...
	char& operator[](const int n) const { return _string[n]; };
	
	// concat strings

	DString& operator=(const DString&);
	
	int strlen(void) { return _string.size(); }
	const char * val(void) { return _string.array(); }
	int getline(istream&);
	
	void stats(void) { _string.stats(); }

protected:
	DStore<char> _string;
};

#endif

