
// FILE: balance.cpp

#include <iostream.h>
#include <exception.h>

#include "balance.h"
#include "stack.h"

static int balanced(char s[]) throw(xmsg);

void balance(void)
{
	char s[256]; // inherently dangerous
	cout << "Enter expressions containing parentheses, braces and brackets" << endl;
	cout << "(. to stop)" << endl;
	do {
		cin >> s;
		cout << "read: " << s << endl;
		try {
			int bal = balanced(s);
			cout << s << " is ";
			if (!bal) {
				cout << "not ";
			}
			cout << "balanced" << endl;
		} catch (xmsg &err) {
			cout << "Exception: " << err.why() << endl;
		}
	} while(s[0] != '.');	
}

int balanced(char s[]) throw(xmsg)
{
	Stack myStack;
	int i=0;
	while (s[i] != '\0') {
		// cout << "stack = "; myStack.print(cout); cout << endl;
		cout << "stack = " << myStack << endl;
		switch (s[i]) {
		case '(':
			myStack.push(')');
			// cout << "Pushed " << ')' << endl;
			break;
		case '[':
			myStack.push(']');
			// cout << "Pushed " << ']' << endl;
			break;
		case '{':
			myStack.push('}');
			// cout << "Pushed " << '}' << endl;
			break;
		case ')':
		case ']':
		case '}':
			if (myStack.empty()) {
				// cout << "Empty stack!" << endl;
				return 0;
			} else if (s[i] == myStack.top()) {
				// cout << "Popped " << ((char)myStack.top()) << endl;
				myStack.pop();
			} else {
				// cout << "Found " << ((char)myStack.top()) << " != " << s[i] << endl;
				return 0;
			}
			break;
		default:
			// cout << "Character <" << s[i] << "> ignored" << endl;
			break;
		}
		i++;
	}
	return myStack.empty();
}
