
// FILE: queue.h

#ifndef QUEUE_H
#define QUEUE_H

#include <exception.h>
#include <iostream.h>
#include "llist.h"

// typedef char* Item; // Redefine as necessary (alternative to templates)

typedef int Item; // Redefine as necessary (alternative to templates)

class Queue
{	

public:
	Queue(void) { };
	~Queue(void) { };

	// inline functions:
	int count(void) { return myList.count(); };
	int empty(void) { return myList.empty(); };

	// join queue at tail with enqueue()
	// leave queue at head with dequeue()
	Item head(void) throw(xmsg) { return myList.front(); }
	void dequeue(void) throw(xmsg) { myList.pop_front(); }
	Item tail(void) throw(xmsg) { return myList.back(); }
	void enqueue(Item item) { myList.push_back(item); }
	
	void print(ostream &os) { myList.print(os); }

private:
	LList myList;
};

inline ostream& operator<< (ostream& os, Queue& q) { q.print(os); return os; }

#endif // QUEUE_H
