
// File: crev.cpp
// Author: Oscar Nierstrasz 30.11.95

#include <iostream.h>
#include <exception.h>

#include "store.h"

const int bufSize = 256;

int main(void)
{
	Store ioStack;
	char * buf;

	try {
		buf = new char[bufSize];
		//
		// Push input lines onto stack
		//
		while (!cin.getline(buf, bufSize).eof()) {
		// while (!cin.get(*buf).eof()) {
			ioStack.push(buf);
			buf = new char[bufSize];
			// buf = new streambuf;
		}

		//
		// Pop them off in reverse order
		// and print them all
		//
		// Store copyStack = ioStack; // test assignment
		Store copyStack;
		copyStack = ioStack; // test assignment

		while (copyStack.size() != 0) {
			cout << copyStack.top() << endl;;
			delete [] copyStack.top();
			copyStack.pop();
		}

/*
		Store * refStack;
		refStack = new Store(ioStack); // copy constructor

		while (refStack->size() != 0) {
			cout << refStack->top() << endl;;
			delete [] refStack->top();
			refStack->pop();
		}
*/

	}
	catch (xmsg &err) {
		cout << "Exception: " << err.why() << endl;
	}
}

