// File: fact.cpp

#include "fact.h"
#include <iostream.h>

void testFact(void)
{
	unsigned int n;
	cout << "Enter a non-negative number: ";
	cin >> n;
	cout << "rfactorial(" << n << ") = " << rfactorial(n) << endl;
	cout << "trfactorial(" << n << ") = " << trfactorial(n) << endl;
	cout << "ifactorial(" << n << ") = " << ifactorial(n) << endl;
}

int rfactorial(unsigned int n)		// recursive, but not tail-recursive
{
	if (n==0) {
		return 1;
	} else {
		return n*rfactorial(n-1);
	}
}

int trfactorial(unsigned int n, unsigned int result)
{
	if (n==0) {
		return result;
	} else {
		return trfactorial(n-1, n*result);
	}
}

int ifactorial(unsigned int n)
{
	int result = 1;
	while (n != 0) {	// terminate loop with base case(s)
		result = n*result;
		n--;		// loop instead of calling recursively with n-1
	}
	return result;
}

