
/*
	rfib.C -- recursive Fibonacci function
*/

#include <iostream.h>
#include <stdlib.h>

#define DEBUG

int rfib(int);
void fib40(void);

int main(int argc, char* argv[])
{
	if (argc <= 1) {
		cout << "no args" << endl;
		fib40();
	} else {
		int i;
		for (i=1; i<argc; i++) {
			// cout << "argc[" << i << "] = " << argv[i] << endl;
			cout << "rfib(" << argv[i] << ") = "
				<< rfib(atoi(argv[i])) << endl;
		}
	}
	return 0;
}

int
rfib (int n)
{
	switch (n) {
	case 0 :
	case 1 :
		return 1;
		break;
	default :
		return rfib(n-1) + rfib(n-2);
		break;
	}
}

void fib40(void)
{
	int i;
	for (i=0;;i++) {
		cout << "rfib(" << i << ") = " << rfib(i) << endl;
	}
}

