
// FILE: stack.h

#ifndef STACK_H
#define STACK_H

#include <exception.h>
#include <iostream.h>
#include "llist.h"

// typedef char* Item; // Redefine as necessary (alternative to templates)

typedef int Item; // Redefine as necessary (alternative to templates)

class Stack
{	

public:
	Stack(void) { };
	~Stack(void) { };

	// inline functions:
	int count(void) { return myList.count(); };
	int empty(void) { return myList.empty(); };

	// NB: pop() does not return a value
	// use top() before pop() to retrieve the value

	void push(Item item) { myList.push_front(item); }
	Item top(void) throw(xmsg) { return myList.front(); }
	void pop(void) throw(xmsg) { myList.pop_front(); }
	
	void print(ostream &os) { myList.print(os); }

private:
	LList myList;
};

inline ostream& operator<< (ostream& os, Stack& s) { s.print(os); return os; }

#endif // STACK_H

