
#include <iostream.h>

class myClass
{
public:
	myClass(void) {
		cout << "ctor" << endl;
	}
	myClass(myClass& copy) {
		cout << "copy ctor" << endl;
	}
	myClass& operator=(myClass& copy) {
		cout << "operator=" << endl;
		return copy;
	}
};

int
main(void)
{
	cout << "myClass a;" << endl;
	myClass a;

	cout << "myClass b = a;" << endl;
	myClass b = a;

	cout << "myClass c(b);" << endl;
	myClass c(b);

	// some compilers (CC and g++) will call copy ctor once
	// others (CW) will call it twice!
	cout << "myClass d = myClass(c);" << endl;
	myClass d = myClass(c);

	return 0;
}

