
/*
	File: tttMain.cpp
	Author: Oscar Nierstrasz 29.2.96

	Driver for Tic Tac Toe program
*/

#include <iostream.h>
#include "TicTacToe.h"

void playTicTacToe(void);
// void playTicTacToe(void) { cout << "not implemented yet" << endl; }

int main(void)
{

	cout << "Welcome to Tic Tac Toe!" << endl;
	cout << "Would you like to play a game? (y/n): ";

	char reply;
	cin >> reply;
	while (reply == 'y')  {
		playTicTacToe();
		cout << "Would you like to play another game? (y/n): ";
		cin >> reply;
	}
	cout << "Goodbye!" << endl;
	return 0; // Unix process terminates without error
}

void playTicTacToe (void)
{
	TicTacToe game; // new local instance
	int move;

	while (game.notover())  {
		game.print();
		cout << game.turn() << " plays: ";
		// cout << game << game.turn() << " plays: ";
		cin >> move;
		try  {
			game.play(move);
		}
		catch (xmsg &err) {
			// cout << "Error: " << err.what() << endl;
			cout << "Error: " << err.why() << endl;
		}
	}
	game.print();
	cout << game.winner() << " wins!!!" << endl << endl;

	// char * s = game.winner(); // illegal conversion
	// const char * s = game.winner();
	// *s = '*'; // illegal assignment to constant

	// cout << game << game.winner() << " wins!!!" << endl << endl;
}

