
// Hi oscar,
// This compiles, but crashes
// Greetings,
// Willem

// g++: ****Pure virtual function called
// CC: ****Pure virtual function called Abort (core dumped)


#include <iostream.h>

class Printer;

class Abstract		// NB: abstract class since hello is pure virtual
{
public:
	Abstract (Printer* printer);
	// implemented after Printer's interface is defined ...
	virtual void hello (void) = 0; // NB: pure virtual
};

class Concrete : public Abstract
{
public:
	Concrete (Printer* printer) : Abstract (printer) { }
	void hello (void) { cout << "Hello " << endl; }
};

// Used to announce creation of instances of subclasses of Abstract
class Printer
{
public:
	Printer (void) { }
	void inform (Abstract* abstract) { abstract-> hello (); }
};

Abstract::Abstract (Printer* printer) { printer->inform(this); }

main (void)
{
	Printer* printer = new Printer;
	Concrete* concrete = new Concrete (printer);
	// Since the this pointer in Abstract constructor is statically bound
	// to Abstract, hello is called in Abstract instead of Concrete
}

